package project1;
public class Linkedd {
	protected DNode head;
	public DNode getHead() {
		return this.head;
	}

	public void addAtStart(int cof,int exp) {
		DNode newNode = new DNode(cof, exp);
		newNode.setNextNode(this.head);
		this.head = newNode;
	}
	
	public void freeTheList(){
		this.head=null;
		
	}

	public void setHead(DNode data) {
		this.head = data;
	}

	public DNode deleteAtStart() {
		DNode toDel = this.head;
		this.head = this.head.getNextNode();
		return toDel;
	}

	public DNode find(int data) {
		DNode curr = this.head;
		while (curr != null) {
			if (curr.getExp()==data) 
				return curr;			
			curr = curr.getNextNode();
		}
		return null;
	}

	public int length() {
		int length = 0;
		DNode curr = this.head;
		while (curr != null) {
			length++;
			curr = curr.getNextNode();
		}
		return length;
	}

	public boolean isEmpty() {
		return this.head == null;
	}

	@Override
	public String toString() {
		String res = "Head==>";
		DNode curr = this.head;
		while (curr != null) {
			res += curr + " --> ";
			curr = curr.getNextNode();
		}
		return res + "NULL";
	}
}
